<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task75</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">
  
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="country.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="district.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>District</p>
                </a>
              </li>

            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">District</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">District</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <div class="d-flex justify-content-center mt-5">
        <div class="card card-danger w-50">
            <div class="card-header">
                <h3 class="card-title">District</h3>
            </div>
            <div class="card-body">
              <div class="row form-group">
                <label for="" class="col-sm-3">Country</label>
                <div class="col-sm-9">
                    <select name="country" id="select-country" class="form-control">
                        <option value="none">Chọn country</option>
                    </select>
                </div>
            </div>

              <div class="row form-group">
                <label for="" class="col-sm-3">Region</label>
                <div class="col-sm-9">
                    <select name="region" id="select-region" class="form-control">
                        <option value="none">Chọn region</option>
                    </select>
                </div>
            </div>
            

                <div class="row form-group">
                    <label for="" class="col-sm-3">District Code</label>
                    <div class="col-sm-9">
                        <input id="inp-district-code" type="text" class="form-control">
                    </div>
                </div>
                
                <div class="row form-group">
                  <label for="" class="col-sm-3">District Name</label>
                  <div class="col-sm-9">
                      <input id="inp-district-name" type="text" class="form-control">
                  </div>
              </div>
                
                <div class="row form-group">
                    <div class="col-sm-6">
                        <button id="btn-add" class="btn btn-primary">Add</button>
                        <button id="btn-update" class="btn btn-primary" style="display: none;">Update</button>
                        <button id="btn-delete" class="btn btn-danger" style="display: none;">Delete</button>
                        
                    </div>
                </div>
                
            </div>
        </div>

    </div>
    <table id="table-district" class="table table-stripped table-bordered table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>District Code</th>
                <th>District Name</th>
            </tr>
        </thead>
        <tbody>

        </tbody>
    </table>
    </div>
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableDistrict = $("#table-district").DataTable({
        columns: [
            { data: "id"},
            { data: "districtCode"},
            { data: "districtName"}
        ]
    });

    var gDistrictId = null;
    var gDistrictId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    // Thực thi sự kiện chọn province thì load ra list district của province đó trong thẻ select
    $("#select-country").on("change", function() {
        callApiToLoadDataToSelectRegion();
    });

    // Thực thi sự kiện chọn district thì load ra list ward ra table
    $("#select-region").on("change", function() {
        callApiToLoadDistrictToTable();
    });

    // Thực thi sự kiện nhấn nút add
    $("#btn-add").on("click", function() {
        onBtnAddClick();
    })

    // Thực thi sự kiện ấn vào row
    $("#table-district").on("click", "tr", function() {
        onClickDistrictRow(this);
    });

    // THực thi sự kiện nhấn nút delete
    $("#btn-delete").on("click", function() {
        onBtnDeleteClick();
    });

    // Thực thi sự kiện nhấn nút update
    $("#btn-update").on("click", function() {
        onBtnUpdateClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    function onPageLoading() {
        callApiloadToSelectCountry();
    }

    
    // Hàm xử lý sự kiện nhấn nút add ward
    function onBtnAddClick() {
        var vNewWard = {
            districtCode: "",
            districtName: ""
        }
        getNewDistrictData(vNewWard);
        var vValidate = validateDistrict(vNewWard);
        console.log(vNewWard);
        if(vValidate) {
            callApiToCreateNewDistrict(vNewWard);
        }
    }   

    // Hàm xử lý sự kiện nhấn nút add ward
    function onBtnUpdateClick() {
        var vNewDistrict = {
            districtCode: "",
            districtName: ""
        }
        getNewDistrictData(vNewDistrict);
        var vValidate = validateDistrict(vNewDistrict);
        console.log(vNewDistrict);
        if(vValidate) {
            callAPiToUpdateDistrict(vNewDistrict);
        }
    }

    // Hàm xử lý sự kiện nhấn vào row ward
    function onClickDistrictRow(paramRow) {
        var vDataRow = gTableDistrict.row(paramRow).data();
        console.log(vDataRow);
        gDistrictId = vDataRow.id;
        $("#inp-district-code").val(vDataRow.districtCode);
        $("#inp-district-name").val(vDataRow.districtName);
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();
    }

    // Hàm sự kiện nhất nút cancel
    function onBtnCancelClick() {
        clearData();
    }

    // Hàm sự kiện nhấn nút delete
    function onBtnDeleteClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/districts/" + gDistrictId,
            success: function(paramRes) {
                alert("Xóa thành công!");
                callApiToLoadDistrictToTable();
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm load danh sách province vào thẻ select province
    function callApiloadToSelectCountry() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/countries",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToSelectCountry(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        })
    }


    // Hàm load dữ liệu province vào thẻ select province
    function loadDataToSelectCountry(paramCountryData) {
        var vSelectCountry = $("#select-country");
        for(var bI = 0; bI < paramCountryData.length; bI++) {
            $("<option>", {
                value: paramCountryData[bI].id,
                text: paramCountryData[bI].countryName
            }).appendTo(vSelectCountry);
        }
    }

    // Hàm gọi API để load dữ liệu select district
    function callApiToLoadDataToSelectRegion() {
        var vCountryId = $("#select-country").val();
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/country/" + vCountryId + "/region",
            success: function(paramRes) {
                loadDataToSelectRegion(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        });
    }

    // Hàm load dữ liệu vào select district
    function loadDataToSelectRegion(paramRegionData) {
        var vSelectDistrict = $("#select-region");
        vSelectDistrict.html("");
        $("<option>", {
                value: "none",
                text: "Chọn region"
            }).appendTo(vSelectDistrict);
        for(var bI = 0; bI < paramRegionData.length; bI++) {
            $("<option>", {
                value: paramRegionData[bI].id,
                text: paramRegionData[bI].regionName
            }).appendTo(vSelectDistrict);
        }
    }

    // Hàm call Api để load list ward ra table
    function callApiToLoadDistrictToTable() {
        var vRegionId = $("#select-region").val();
        $.ajax({
            type: "GET", 
            url: "http://localhost:8080/regions/" + vRegionId + "/districts",
            success: function(paramRes) {
                loadDataToTable(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        })
    }

    // Hàm load dữ liệu vào table
    function loadDataToTable(paramDistrictData) {
        gTableDistrict.clear();
        gTableDistrict.rows.add(paramDistrictData);
        gTableDistrict.draw();
    }

    // Hàm lấy thông tin ward từ form
    function getNewDistrictData(paramDataWard) {
        paramDataWard.districtCode = $("#inp-district-code").val();
        paramDataWard.districtName = $("#inp-district-name").val();
        console.log(paramDataWard);
    }

    // Hàm validate dữ liệu
    function validateDistrict(paramDataDistrict) {
        if(paramDataDistrict.districtCode == "") {
            alert("Vui lòng nhập District Code");
            return false;
        }
        if(paramDataDistrict.districtName == "") {
            alert("Vui lòng nhập District Name");
            return false;
        }
        return true;
    }

    // Hàm gọi API để tạo mới 1 ward
    function callApiToCreateNewDistrict(paramDataDistrict) {
        var vRegionId = $("#select-region").val();
        $.ajax({
            type: "POST", 
            url: "http://localhost:8080/regions/" + vRegionId + "/districts",
            contentType: "application/json",
            data: JSON.stringify(paramDataDistrict),
            success: function(paramRes) {
                alert("Tạo mới thành công!");
                callApiToLoadDistrictToTable();
            },
            error: function(error) {
                alert("Tạo mới thất bại");
                console.log(error.status);
            }
        })
    }

    // Hàm clear data
    function clearData() {
        gTableDistrict.clear();
        gTableDistrict.rows.add("");
        gTableDistrict.draw();
        $("#inp-district-code").val("");
        $("#inp-district-name").val("");
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
    }

    // Gọi API Để sửa 1 ward
    function callAPiToUpdateDistrict(paramDataWard) {
        var vRegionId = $("#select-region").val();
        $.ajax({
            type: "PUT", 
            url: "http://localhost:8080/regions/" + vRegionId + "/districts/" + gDistrictId,
            contentType: "application/json",
            data: JSON.stringify(paramDataWard),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                callApiToLoadDistrictToTable();
            },
            error: function(error) {
                alert("Cập nhật thất bại");
                console.log(error.status);
            }
        })
    }

</script>
</body>

</html>